/* zaddin.c for X680x0 */

#include	"emu_fio.h"
#include	"emu_str.h"
#include	"zaddin.h"
#include	"iofunc.h"

#define		PACKET_SIZE	(1024*2)
#define		BUF_SIZE	(1024*128)
#define		BLINE		256

ZaurusRecv( fileZ, file68 )
char	*fileZ, *file68;
{
	unsigned char	*ptr;
	if( ptr= SysAlloc( BUF_SIZE ) ){
		int	length= RecvFileData( BUF_SIZE, ptr, fileZ );
		ExitZaurus( FALSE );
		if( length >= 0 ){
			if( !McreateWrite( file68, ptr, length ) )
				Error( "", "t@C܂" );
		}
		SysFree( ptr );
		return	length;
	}else{
		Error( "", "mۂł܂" );
	}
	return	-1;
}

ZaurusSend( file68, fileZ )
char	*fileZ, *file68;
{
	unsigned char	*ptr;
	if( ptr= MallocRead( file68 ) ){
		int	length= MallocSize( ptr );
		SendFileData( length, ptr, fileZ );
		SysFree( ptr );
	}else{
		Error( file68, " t@C܂" );
		return	FALSE;
	}
	ExitZaurus( FALSE );
	return	FALSE;
}

ZaurusBackup( table, dir )
char	*table, *dir;
{
	m_file	fm;
	char	buf[BLINE], buf1[BLINE];
	Error( "obNAbv","" );
	if( Mopen( &fm, table ) ){
		for(; Mgets( &fm, buf, BLINE ) >= 0 ;){
			if( *buf != '#' ){
				Mprint( buf );
				Mprint( " :" );
				s_strcpy(
				s_strcpy( buf1, s_strpath( dir ) ), buf );
				if( !ZaurusRecv( buf1, buf ) ){
			Error( "t@C܂"," ܂" );
				}
			}
		}
		Mclose( &fm );
	}
	Error( "I","" );
}

ZaurusRestore( table, dir )
char	*table, *dir;
{
	m_file	fm;
	char	buf[BLINE], buf1[BLINE];
	Error( "XgA","" );
	if( Mopen( &fm, table ) ){
		for(; Mgets( &fm, buf, BLINE ) >= 0 ;){
			if( *buf != '#' ){
				Mprint( buf );
				Mprint( " :" );
				s_strcpy(
				s_strcpy( buf1, s_strpath( dir ) ), buf );
				ZaurusSend( buf, buf1 );
			}
		}
		Mclose( &fm );
	}
	Error( "I","" );
}

main( argc, argv )
char	**argv;
{
	int	f_get= TRUE, speed= DEF_SPEED;
	char	*file= 0, *file2= 0;
	Error( "zbackup v1.4 ZAURUS obNAbv", " 1995 COR." );
	for(; --argc ;){
		if( **++argv == '-' && (*argv)[1] ){
			switch( (*argv)[1] ){
			case 's':
				speed= (*argv)[2]&3;
				continue;
			case 'p':
			case 'r':
				f_get= FALSE;
				continue;
			case 'g':
				f_get= TRUE;
				continue;
#if UNIX
			case 'd':
				DEV_SWITCH();
#endif
			default:
				file= 0;
			}
			break;
		}else{
			if( file )
				file2= *argv;
			else
				file= *argv;
		}
	}
	if( file ){
		if( !file2 )
			file2= "./";
		RsInit( speed );
		if( f_get )
			ZaurusBackup( file, file2 );
		else
			ZaurusRestore( file, file2 );
		ResetZaurus();
		ExitZaurus();
		RsQuit();
	}else{
		Print( "\
usage: zlink    [-s0|1|2] <tablefile> [<BackupDIR>] (backup  ZAURUS->X68K)\r\n\
       zlink -r [-s0|1|2] <tablefile> [<BackupDIR>] (restore X68K->ZAURUS)\r\n\
"
		);
	}
	SysExit( 0 );
}

