/* zaddin.c for X680x0 */

#include	"emu_fio.h"
#include	"emu_str.h"
#include	"zaddin.h"
#include	"iofunc.h"

#define		PACKET_SIZE	(1024*2)
#define		BUF_SIZE	(1024*128)

static char	fileZ[]= "COM0.LOG";

#if UNIX
CR_Change( ptr, length )
unsigned char	*ptr;
{
	for(; --length ; ptr++ ){
		if( *ptr == '\r' )
			*ptr= '\n';
	}
}
LF_Change( ptr, length )
unsigned char	*ptr;
{
	for(; --length ; ptr++ ){
		if( *ptr == '\n' )
			*ptr= '\r';
	}
}
#endif

ZaurusRecv( ch, file68 )
char	*file68;
{
	unsigned char	*ptr;
	if( ptr= SysAlloc( BUF_SIZE ) ){
		int	length= RecvFileData( BUF_SIZE, ptr, fileZ );
		ExitZaurus( FALSE );
		if( length >= 0 ){
#if UNIX
			CR_Change( ptr, length );
#endif
			if( McreateWrite( file68, ptr, length ) ){
				return	TRUE;
			}else
				Error( "", "t@C܂" );
		}
		SysFree( ptr );
	}else{
		Error( "", "mۂł܂" );
	}
	return	FALSE;
}

ZaurusSend( ch, file68 )
char	*file68;
{
	unsigned char	*ptr;
	if( ptr= MallocReadTopOffset( file68, 25 ) ){
		int	length= MallocSize( ptr );
#if UNIX
		LF_Change( ptr, length );
#endif
		s_memcpy_simple( 25, ptr, "#01;19100101 000000\r###;\r" );
		ptr[7]= '0'+ch;
		SendFileData( length, ptr, fileZ );
		SysFree( ptr );
	}else{
		Error( file68, ":file open error" );
	}
	ExitZaurus( FALSE );
	return	FALSE;
}


main( argc, argv )
char	**argv;
{
	int	f_get= FALSE, speed= DEF_SPEED, ch= 0;
	char	*file= 0, *file2= 0;
	Error( "zfile v1.4 ZAURUSlbgt@C]", " 1995 COR." );
	for(; --argc ;){
		if( **++argv == '-' && (*argv)[1] ){
			switch( (*argv)[1] ){
			case 's':
				speed= (*argv)[2]&3;
				continue;
			case 'c':
				ch= (*argv)[2]&15;
				if( ch >= 9 )
					ch= 0;
				continue;
			case 'g':
				f_get= TRUE;
				continue;
#if UNIX
			case 'd':
				DEV_SWITCH();
#endif
			default:
				file= 0;
			}
			break;
		}else
			file= *argv;
	}
	if( file ){
		RsInit( speed );
		fileZ[3]= '0'+ch;
		if( f_get )
			ZaurusRecv( ch, file );
		else
			ZaurusSend( ch, file );
/* gcc only ..	(f_get ? ZaurusRecv : ZaurusSend)( ch, file );*/
		RsQuit();
	}else{
		Print( "\
usage: zfile    [-s0|1|2] [-cN] <file>    (X68K->ZaurusNetLog)\r\n\
       zfile -g [-s0|1|2] [-cN] <file>    (ZaurusNetLog->X68K)\r\n\
"
		);
	}
	SysExit( 0 );
}

