/* zaddin.c for X680x0 */

#include	"emu_fio.h"
#include	"emu_str.h"
#include	"zaddin.h"
#include	"iofunc.h"

#define		PACKET_SIZE	(1024*2)
#define		BUF_SIZE	(1024*128)

ZaurusRecv( fileZ, file68 )
char	*fileZ, *file68;
{
	unsigned char	*ptr;
	if( ptr= SysAlloc( BUF_SIZE ) ){
		int	length= RecvFileData( BUF_SIZE, ptr, fileZ );
		ExitZaurus( FALSE );
		if( length >= 0 ){
			if( McreateWrite( file68, ptr, length ) ){
				SysFree( ptr );
				return	TRUE;
			}else
				Error( "", "t@C܂" );
		}
		SysFree( ptr );
	}else{
		Error( "", "mۂł܂" );
	}
	return	FALSE;
}

ZaurusSend( file68, fileZ )
char	*fileZ, *file68;
{
	unsigned char	*ptr;
	if( ptr= MallocRead( file68 ) ){
		int	length= MallocSize( ptr );
		SendFileData( length, ptr, fileZ );
		SysFree( ptr );
	}else{
		Error( file68, ":file open error" );
	}
	ExitZaurus( FALSE );
	return	FALSE;
}


main( argc, argv )
char	**argv;
{
	int	f_get= FALSE, speed= DEF_SPEED;
	char	*file= 0, *file2= 0;
	Error( "zlink v1.4 ZAURUS t@C_CNg]", " 1995 COR." );
	for(; --argc ;){
		if( **++argv == '-' && (*argv)[1] ){
			switch( (*argv)[1] ){
			case 's':
				speed= (*argv)[2]&3;
				continue;
			case 'g':
				f_get= TRUE;
				continue;
#if UNIX
			case 'd':
				DEV_SWITCH();
#endif
			default:
				file= 0;
			}
			break;
		}else{
			if( file )
				file2= *argv;
			else
				file= *argv;
/* gcc only ..		(file ? file2 : file)= *argv;*/
		}
	}
	if( file ){
		if( !file2 )
			file2= file;
		RsInit( speed );
		if( f_get )
			ZaurusRecv( file, file2 );
		else
			ZaurusSend( file, file2 );
/* gcc only ..	(f_get ? ZaurusRecv : ZaurusSend)( file, file2 );*/
		RsQuit();
	}else{
		Print( "\
usage: zlink    [-s0|1|2] <fileX68> [<fileZAU>]      (X68K->ZAURUS)\r\n\
       zlink -g [-s0|1|2] <fileZAU> [<fileX68>]      (ZAURUS->X68K)\r\n\
"
		);
	}
	SysExit( 0 );
}

