/* zaddin.c for X680x0 */

#include	"emu_fio.h"
#include	"emu_str.h"
#include	"zaddin.h"
#include	"iofunc.h"

main( argc, argv )
char	**argv;
{
	int	reset= FALSE, speed= DEF_SPEED;
	Error( "zreset v1.4 ZAURUS p\RNZbg", " 1995 COR." );
	for(; --argc ;){
		if( **++argv == '-' ){
			switch( (*argv)[1] ){
			case 'r':
				reset= TRUE;
				continue;
			case 's':
				speed= (*argv)[2]&3;
				continue;
#if UNIX
			case 'd':
				DEV_SWITCH();
#endif
			default:
				reset= FALSE;
			}
			break;
		}
	}
	if( reset ){
		RsInit( speed );
		ResetZaurus();
		ExitZaurus();
		RsQuit();
	}else
		Error( "usage:", " zreset [-s0|1|2] -r" );
	SysExit( 0 );
}

