/* iofunc.c  for X680x0 */

#if HUMAN68K
# include	<sys_doslib.h>

# define	Print(msg)	PRINT(msg)
# define	SysClock()	ONTIME()
# define	SysExit(cd)	EXIT2(cd)
# define	RsRecvCheck()	LOF232C()
# define	RsRecv()	INP232C()
# define	RsSendCheck()	OSNS232C()
# define	RsSend(cd)	OUT232C(cd)
# define	RsQuit()
# define	SysFree(ptr)	MFREE(ptr)
# define	DEF_SPEED	1
# define	DEV_SWITCH()

extern void	*SysAlloc();

#endif

#if UNIX

#include	<stdlib.h>

# define	SysAlloc(size)	(void*)malloc(size)
# define	SysFree(ptr)	free(ptr)
# define	DEF_SPEED	0
# define	DEV_SWITCH()	if( argc >= 2 ){ \
					extern char ttydevice[]; \
					s_strcpy( ttydevice, *++argv ); \
					argc--; \
					continue; \
				}

#endif

extern int	zio_TimeOut;
#define		TIMEOUT		-1

